(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-pattern', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-pattern'] = {}, global.ng.core));
}(this, function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxPatternDirective = /** @class */ (function () {
        function NgxPatternDirective(host) {
            this.host = host;
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        NgxPatternDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (this.ngxPattern) {
                if (typeof this.ngxPattern === 'string') {
                    this.regex = new RegExp("^" + this.ngxPattern + "$", 'g');
                }
                else {
                    this.regex = this.ngxPattern;
                }
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        NgxPatternDirective.prototype.onKeyPress = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (this.regex && !e.ctrlKey && !isSpecialKey(e.key)) {
                if (!this.validWithChange(e.key)) {
                    e.preventDefault();
                }
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        NgxPatternDirective.prototype.onPaste = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var pastedInput = e.clipboardData.getData('text/plain');
            if (!this.validWithChange(pastedInput)) {
                e.preventDefault();
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        NgxPatternDirective.prototype.onDrop = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            /** @type {?} */
            var textData = e.dataTransfer.getData('text');
            if (!this.validWithChange(textData)) {
                e.preventDefault();
            }
        };
        /**
         * @private
         * @param {?} delta
         * @return {?}
         */
        NgxPatternDirective.prototype.validWithChange = /**
         * @private
         * @param {?} delta
         * @return {?}
         */
        function (delta) {
            var _a = this.inputEl, current = _a.value, selectionStart = _a.selectionStart, selectionEnd = _a.selectionEnd;
            /** @type {?} */
            var updated = current.substring(0, selectionStart) + delta + current.substring(selectionEnd + 1);
            /** @type {?} */
            var result = !updated || this.regex.test(updated);
            this.regex.lastIndex = 0;
            return result;
        };
        Object.defineProperty(NgxPatternDirective.prototype, "inputEl", {
            get: /**
             * @return {?}
             */
            function () {
                return this.host.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        NgxPatternDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxPattern]'
                    },] }
        ];
        /** @nocollapse */
        NgxPatternDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        NgxPatternDirective.propDecorators = {
            ngxPattern: [{ type: core.Input }],
            onKeyPress: [{ type: core.HostListener, args: ['keydown', ['$event'],] }],
            onPaste: [{ type: core.HostListener, args: ['paste', ['$event'],] }],
            onDrop: [{ type: core.HostListener, args: ['drop', ['$event'],] }]
        };
        return NgxPatternDirective;
    }());
    if (false) {
        /** @type {?} */
        NgxPatternDirective.prototype.ngxPattern;
        /**
         * @type {?}
         * @private
         */
        NgxPatternDirective.prototype.regex;
        /**
         * @type {?}
         * @private
         */
        NgxPatternDirective.prototype.host;
    }
    /**
     * @see https://developer.mozilla.org/bg/docs/Web/API/KeyboardEvent/key/Key_Values
     * @param {?} key
     * @return {?}
     */
    function isSpecialKey(key) {
        return key.length > 1;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxPatternModule = /** @class */ (function () {
        function NgxPatternModule() {
        }
        NgxPatternModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NgxPatternDirective],
                        imports: [],
                        exports: [
                            NgxPatternDirective
                        ]
                    },] }
        ];
        return NgxPatternModule;
    }());

    exports.NgxPatternDirective = NgxPatternDirective;
    exports.NgxPatternModule = NgxPatternModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-pattern.umd.js.map
